//--------------------------------------------------------
//  Forex Expert Advisor Generator version 2.03 EA
//--------------------------------------------------------

#property copyright "Copyright  2010, Forex EA Generator v2.03"
#property link      "http://www.forexgenerator.com/"
#include <stdlib.mqh>

// exported variables
extern double BuyLots18 = 0.1;
extern int BuyStoploss18 = 15;
extern int BuyTakeprofit18 = 20;
extern double SellLots25 = 0.1;
extern int SellStoploss25 = 15;
extern int SellTakeprofit25 = 20;


// local variables
double PipValue=1;    // this variable is here to support 5-digit brokers
bool Terminated = false;
int Count1 = 0;


int init()
{
    
    Comment("");    // clear the chart
}

// Expert start
int start()
{
    if (Bars < 10)
    {
        Comment("Not enough bars");
        return (0);
    }
    if (Terminated == true)
    {
        Comment("EA Terminated.");
        return (0);
    }
    
    OnEveryTick2();
    
}

void OnEveryTick2()
{
    if (true) PipValue = 10;
    PrintInfoToChart1();
    TechnicalAnalysis2x3();
    TechnicalAnalysis2x8();
    
}

void PrintInfoToChart1()
{
    string temp = "Some Text\nExecuted : " + Count1 + "\n"
    + "Spread: " + DoubleToStr(MarketInfo(Symbol(), MODE_SPREAD)/PipValue, 2)+ "\n"
    + "------------------------------------------------\n"
    + "ACCOUNT INFORMATION:\n"
    + "\n"
    + "Account Name:     " + AccountName()+ "\n"
    + "Account Leverage:     " + DoubleToStr(AccountLeverage(), 0)+ "\n"
    + "Account Balance:     " + DoubleToStr(AccountBalance(), 2)+ "\n"
    + "Account Equity:     " + DoubleToStr(AccountEquity(), 2)+ "\n"
    + "Free Margin:     " + DoubleToStr(AccountFreeMargin(), 2)+ "\n"
    + "Used Margin:     " + DoubleToStr(AccountMargin(), 2)+ "\n"
    + "------------------------------------------------\n";
    Comment(temp);
    Count1++;
    
}

void TechnicalAnalysis2x3()
{
    if ((iCustom(NULL, NULL, "ForexFreedomBars",1,5,15,30,30,2,2,2,2,0,1) == 4) && (iCustom(NULL, NULL, "ForexFreedomBars",1,5,15,30,30,2,2,2,2,2,1) == 3))
    {
        TechnicalAnalysis2x10();
        
    }
}

void TechnicalAnalysis2x10()
{
    if ((iCustom(NULL, NULL, "ForexFreedomBars",1,5,15,30,30,2,2,2,2,4,1) == 2) && (iCustom(NULL, NULL, "ForexFreedomBars",1,5,15,30,30,2,2,2,2,6,1) == 1))
    {
        CloseOrder14();
        
    }
}

void CloseOrder14()
{
    int orderstotal = OrdersTotal();
    int orders = 0;
    int ordticket[30][2];
    for (int i = 0; i < orderstotal; i++)
    {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderType() != OP_SELL || OrderSymbol() != Symbol() || OrderMagicNumber() != 1)
        {
            continue;
        }
        ordticket[orders][0] = OrderOpenTime();
        ordticket[orders][1] = OrderTicket();
        orders++;
    }
    if (orders > 1)
    {
        ArrayResize(ordticket,orders);
        ArraySort(ordticket);
    }
    for (i = 0; i < orders; i++)
    {
        if (OrderSelect(ordticket[i][1], SELECT_BY_TICKET) == true)
        {
            bool ret = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 4, Red);
            if (ret == false)
            Print("OrderClose() error - ", ErrorDescription(GetLastError()));
        }
    }
    IfOrderDoesNotExist16();
    
}

void IfOrderDoesNotExist16()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OP_BUY && OrderSymbol() == Symbol() && OrderMagicNumber() == 1)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists == false)
    {
        BuyOrder18();
        
    }
}

void BuyOrder18()
{
    
    int ticket = OrderSend(Symbol(), OP_BUY, BuyLots18, Ask, 4, 0, 0, "My Buy", 1, 0, Blue);
    if (ticket > -1)
    {
        OrderSelect(ticket, SELECT_BY_TICKET);
        bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), Ask - BuyStoploss18*PipValue*Point, Ask + BuyTakeprofit18*PipValue*Point, 0, Blue);
        if (ret == false)
        Print("OrderModify() error - ", ErrorDescription(GetLastError()));
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}

void TechnicalAnalysis2x8()
{
    if ((iCustom(NULL, NULL, "ForexFreedomBars",1,5,15,30,30,2,2,2,2,1,1) == 4) && (iCustom(NULL, NULL, "ForexFreedomBars",1,5,15,30,30,2,2,2,2,3,1) == 3))
    {
        TechnicalAnalysis2x11();
        
    }
}

void TechnicalAnalysis2x11()
{
    if ((iCustom(NULL, NULL, "ForexFreedomBars",1,5,15,30,30,2,2,2,2,5,1) == 2) && (iCustom(NULL, NULL, "ForexFreedomBars",1,5,15,30,30,2,2,2,2,7,1) == 1))
    {
        CloseOrder21();
        
    }
}

void CloseOrder21()
{
    int orderstotal = OrdersTotal();
    int orders = 0;
    int ordticket[30][2];
    for (int i = 0; i < orderstotal; i++)
    {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderType() != OP_BUY || OrderSymbol() != Symbol() || OrderMagicNumber() != 1)
        {
            continue;
        }
        ordticket[orders][0] = OrderOpenTime();
        ordticket[orders][1] = OrderTicket();
        orders++;
    }
    if (orders > 1)
    {
        ArrayResize(ordticket,orders);
        ArraySort(ordticket);
    }
    for (i = 0; i < orders; i++)
    {
        if (OrderSelect(ordticket[i][1], SELECT_BY_TICKET) == true)
        {
            bool ret = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 4, Red);
            if (ret == false)
            Print("OrderClose() error - ", ErrorDescription(GetLastError()));
        }
    }
    IfOrderDoesNotExist22();
    
}

void IfOrderDoesNotExist22()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber() == 1)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists == false)
    {
        SellOrder25();
        
    }
}

void SellOrder25()
{
    
    int ticket = OrderSend(Symbol(), OP_SELL, SellLots25, Bid, 4, 0, 0, "My Sell", 1, 0, Red);
    if (ticket > -1)
    {
        OrderSelect(ticket, SELECT_BY_TICKET);
        bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), Bid + SellStoploss25*PipValue*Point, Bid - SellTakeprofit25*PipValue*Point, 0, Red);
        if (ret == false)
        Print("OrderModify() error - ", ErrorDescription(GetLastError()));
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}



int deinit()
{
    
}

